(function($) {
  Drupal.behaviors.layouter = {
    attach: function(context, settings) {
      if (typeof drupalSettings.layouter != 'undefined') {
        var active_text_formats = drupalSettings.layouter.window.active_text_formats;
        var textareas_id = drupalSettings.layouter.window.textareas_id;
        for (var textarea in textareas_id) {
          var format_filter_id = "#" + textarea.replace(/value/, "format--2");
          var format_filter = $(format_filter_id);

          layouter_link = $('#layouter-' + textarea);
          if (active_text_formats.indexOf($(format_filter_id + " option:selected").val()) == -1) {
            layouter_link.parent().hide();
          }

          format_filter.change(function() {
            var format_filter_id = $(this).attr("id");
            var textarea_id = format_filter_id.replace(/format--2/, "") + "value";
            var layouter_link = $('#layouter-' + textarea_id);
            if (active_text_formats.indexOf($('#' + format_filter_id + " option:selected").val()) != -1) {
              layouter_link.parent().show();
            }
            else {
              layouter_link.parent().hide();
            }
          });
        };
      }
    }
  }

  $.fn.layouterAddContent = function(textarea_id, content) {
    if (content) {
      if (typeof CKEDITOR != 'undefined' && typeof CKEDITOR.instances[textarea_id] != 'undefined') {
        CKEDITOR.instances[textarea_id].insertHtml(content);
      }
      if (typeof tinyMCE != 'undefined' && typeof tinyMCE.activeEditor != 'undefined' && tinyMCE.activeEditor != null) {
        if (tinyMCE.activeEditor.editorId == textarea_id) {
          tinyMCE.activeEditor.dom.add(tinyMCE.activeEditor.getBody(), 'div', {}, content);
        }
      }
      var area = $('#' + textarea_id);
      var content = area.val() + content;
      area.val(content);
    }
  }
})(jQuery);
